import { AfterViewInit, Component, OnInit, ViewChild } from '@angular/core';
import { MatDialog } from '@angular/material/dialog';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';
import { GetOrderReception, ResponseDataGetOrderReception } from 'src/app/interfaces/acquisition-management/order-reception.interface';
import { lastValueFrom } from 'rxjs';
import { OrderReceptionService } from 'src/app/services/acquisition-management/order-reception.service';
import { ResourcesService } from 'src/app/services/resources/resources.service';
import { HttpErrorResponse } from '@angular/common/http';
import { ReportProblemsOrdersComponent } from '../../acquisition/orders/report-problems-orders/report-problems-orders.component';
import { Router } from '@angular/router';
import { EncService } from 'src/app/services/enc/enc.service';
import { UsersProfilesService } from 'src/app/services/users-profiles.service';
import { IssureTrackingService } from 'src/app/services/acquisition-management/issure-tracking.service';
import { SocketService } from 'src/app/services/socket.service';
import { UserConsultResponse } from 'src/app/interfaces/user.interface';
import { ProfileInterface } from 'src/app/interfaces/profile.interface';


@Component({
  selector: 'app-order-reception',
  templateUrl: './order-reception.component.html',
  styleUrls: ['./order-reception.component.css']
})
export class OrderReceptionComponent implements AfterViewInit, OnInit {

  @ViewChild(MatPaginator) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;
  public displayedColumns: string[];
  public dataSource: MatTableDataSource<GetOrderReception>;
  public txtBuscador:string;

  public isLoading: boolean;
  public isLoadingForm: boolean;

  constructor(
    public resourcesService: ResourcesService,
    public router: Router,
    private _dialog: MatDialog,
    private _encService: EncService,
    private _socketService: SocketService,
    private _usersProfilesSevice: UsersProfilesService,
    private _orderReceptionService: OrderReceptionService,
  ) {
    this.displayedColumns = [
      'ORCO_NUOR', 
      'LINE_NUPR', 
      'DESP_IDDE', 
      'DESP_NODE', 
      'ORCO_USMO', 
      'ORCO_FEMO', 
      'ORCO_ESTA', 
      'ACCIONES', 
    ];
    this.dataSource = new MatTableDataSource();
    this.txtBuscador = '';
    this.isLoading = false;
    this.isLoadingForm = false;
  }

  async ngOnInit() {
    await this.refreshPermissions();
    await this.getOrderReception();
  }

  ngAfterViewInit(): void {
    this.dataSource.paginator = this.paginator;
    this.dataSource.sort = this.sort;
  }

  private async refreshPermissions() {
    this._socketService.refreshPermissions().subscribe(async (profUpdEnc) => {
      let idUser = localStorage.getItem('idusuario')!;
      let usrInfo: UserConsultResponse = await lastValueFrom(this._usersProfilesSevice.getUser(idUser, idUser, 1));
      let currentProfile = await this._encService.decrypt(localStorage.getItem('perfil')!);

      if(parseInt(currentProfile) != usrInfo.response.PERFIL){
        this.router.navigate(['/sam/home']);
      }

      let profileUpdated = await this._encService.decrypt(`${profUpdEnc}`);
      if(profileUpdated == currentProfile){
        let profile = localStorage.getItem('perfil')!;

        await lastValueFrom(this._usersProfilesSevice.getProfile( profile, idUser, 1 )).then(
          (responseData: ProfileInterface) => {
            if (!responseData.error) {
              let modPerm = responseData.response.PERMISOS.permissions.filter(item => item.id == 'S002V01M05GEAD')[0];
              let funPerm = modPerm.children.filter(item => item.id == 'S002V03S03DESP')[0];
              let panPerm = funPerm.children.filter(item => item.id == "S002V01F01REPE")[0];

              if (panPerm.access === 0) {
                this.router.navigate(['/sam/home']);
              }

            } else {
              this.resourcesService.openSnackBar(`${responseData.msg}`);
            }
          }, ( httpErrorResponse: HttpErrorResponse ) => this.resourcesService.checkErrors(httpErrorResponse)
        );
      }
    });
  }

  public async getOrderReception() {
    this.isLoading = true;
    await lastValueFrom(this._orderReceptionService.getOrderReception()).then(
      (responseData: ResponseDataGetOrderReception) => {
        if (!responseData.error) {
          console.log(responseData.response);
          
          this.dataSource.data = responseData.response;
        } else {
          this.resourcesService.openSnackBar(responseData.msg);
        }
      }, (error: HttpErrorResponse) => this.resourcesService.checkErrors(error)
    );
    this.isLoading = false;
  }

  public async getInformationOrder( element: GetOrderReception) {
    let encOrderNumber: string = await this._encService.encrypt( element.ORCO_NUOR );
    let encProviderNumber: string = await this._encService.encrypt( element.PROV_NUPR );
    this.router.navigate(['/sam/GEAD/ADQU/SEPE/details-order/' + encOrderNumber + '/' + encProviderNumber]);
  }

  public openDialog(typeDialog: string, dataElement: GetOrderReception) {
    if(typeDialog === 'DETAILS') {

    }else if (typeDialog === 'WARNING') {
      this._dialog.open(ReportProblemsOrdersComponent, {
        width: '500px',
        disableClose: true,
        data: dataElement.ORCO_NUOR,
      }).afterClosed().subscribe((result:any) => {
        if (result) {
          this.router.navigate(['/sam/GEAD/DESP/SEPR']);
        }
      });
    }
  }

}

